var g_gameSharedLayer;
var GameLayer = cc.Layer.extend({
    cloudMax:0,
    cloudCurrent:0,
    cloudList:[],
    cat:null,
    step:0,
    rotateSpeed:ROTATE_SPEED,
    labelScore:null,
    moon:null,
    gameState:true,
    ctor:function(){
        g_gameSharedLayer = this;
        this._super();
        this.init();
    },
    init:function () {
        this.cloudList = [];
        this.cloudMax = 0;
        this.cloudCurrent = 0;
        this.cat = null;
        this.step = 0;
        this.rotateSpeed = ROTATE_SPEED;
        this.labelScore = null;
        this.moon = null;
        this.gameState = true;
        winSize = cc.director.getWinSize();
        var bgSprite = new cc.Sprite(res.bg_png);
        bgSprite.setAnchorPoint(0,0);
        this.addChild(bgSprite,0);
        if(GAME_SOUND)
        {
                                cc.audioEngine.playEffect(res.bianchang_mp3);
                                cc.audioEngine.stopAllEffects();
        }
        if(cc.sys.localStorage.getItem('firstVisit'))
        {
            FIRST_VISIT = false;
        }else{
            cc.sys.localStorage.setItem('firstVisit','false');
            switch(cc.sys.language)
            {
                case 'en':
                    var helpText = new cc.Sprite(res.help_text_en_png);
                    break;
                case 'zh':
                    var helpText = new cc.Sprite(res.help_text_png);
                    break;
                default:
                    var helpText = new cc.Sprite(res.help_text_png);
                    break;
            }
            helpText.setPosition(winSize.width/2,winSize.height-550);
            this.addChild(helpText,10,CAT_TAG_LIST.helpText);
        }
        this.moon = new cc.Sprite(res.moon_png);
        this.moon.scale = MOON_INIT_SCALE;
        this.moon.setPosition(winSize.width/2,winSize.height-this.moon.height/2*this.moon.scale);
        this.addChild(this.moon,1);
        SCORE = 0;
        this.initCloud(true);
        this.initCloud();
        this.initCat();

        if ('mouse' in cc.sys.capabilities)
        {
            cc.eventManager.addListener({
                event: cc.EventListener.MOUSE,
                onMouseDown: function(event){
                    if(FIRST_VISIT)
                    {
                        g_gameSharedLayer.getChildByTag(CAT_TAG_LIST.helpText).active = false;
                        g_gameSharedLayer.getChildByTag(CAT_TAG_LIST.helpText).visible = false;
                    }else{
                        console.log(event.getCurrentTarget());
                        if(event.getButton() == cc.EventMouse.BUTTON_LEFT)
                        {
                            if(event.getCurrentTarget().step==1)
                            {
                                event.getCurrentTarget().changeToGo();
                                event.getCurrentTarget().step = 2;
                            }
                        }
                    }
                }
            }, this);

            cc.eventManager.addListener({
                event: cc.EventListener.MOUSE,
                onMouseUp: function(event){
                    if(FIRST_VISIT)
                    {
                        g_gameSharedLayer.getChildByTag(CAT_TAG_LIST.helpText).active = false;
                        g_gameSharedLayer.getChildByTag(CAT_TAG_LIST.helpText).visible = false;
                        FIRST_VISIT = false;
                    }else{
                        console.log(event.getCurrentTarget());
                        if(event.getButton() == cc.EventMouse.BUTTON_LEFT)
                        {
                            if(event.getCurrentTarget().step==2)
                            {
                                event.getCurrentTarget().changeGo();
                                g_gameSharedLayer.step = 3;
                            }else if(event.getCurrentTarget().step==0){
                                event.getCurrentTarget().changeReady();
                                g_gameSharedLayer.step = 1;
                            }
                        }
                    }
                }
            }, this);
        }
        if (cc.sys.capabilities.hasOwnProperty('touches')){
            cc.eventManager.addListener({
                event: cc.EventListener.TOUCH_ALL_AT_ONCE,
                onTouchesBegan:function (touches, event) {
                    var touch = touches[0];
                    if(FIRST_VISIT)
                    {
                        g_gameSharedLayer.getChildByTag(CAT_TAG_LIST.helpText).active = false;
                        g_gameSharedLayer.getChildByTag(CAT_TAG_LIST.helpText).visible = false;
                    }else{
                        if(event.getCurrentTarget().step==1)
                        {
                            event.getCurrentTarget().changeToGo();
                            event.getCurrentTarget().step = 2;
                        }
                    }
                }
            }, this);
            cc.eventManager.addListener({
                event: cc.EventListener.TOUCH_ALL_AT_ONCE,
                onTouchesEnded:function (touches, event) {
                    var touch = touches[0];
                    if(FIRST_VISIT)
                    {
                        g_gameSharedLayer.getChildByTag(CAT_TAG_LIST.helpText).active = false;
                        g_gameSharedLayer.getChildByTag(CAT_TAG_LIST.helpText).visible = false;
                        FIRST_VISIT = false;
                    }else{
                        if(event.getCurrentTarget().step==2)
                        {
                            event.getCurrentTarget().changeGo();
                            g_gameSharedLayer.step = 3;
                        }else if(event.getCurrentTarget().step==0){
                            event.getCurrentTarget().changeReady();
                            g_gameSharedLayer.step = 1;
                        }
                    }
                }
            }, this);
        }

        this.labelScore = new cc.LabelBMFont("",res.arial_custom_fnt);
        this.labelScore.setAnchorPoint(0.5,0.5);
        this.labelScore.setPosition(this.moon.x,this.moon.y+10);
        this.addChild(this.labelScore,4);

        this.schedule(this.update);
    },
    initCloud:function(first)
    {
        cloud = new cc.Sprite(res.cloud_png);
        cloud.scale = 0.3+Math.random()*0.7;
        console.log(cloud);

        this.cloudCollide = [];
        this.cloudCollide[0] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[0].setPosition(125,155);
        cloud.addChild(this.cloudCollide[0]);
        this.cloudCollide[1] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[1].setPosition(115,153);
        cloud.addChild(this.cloudCollide[1]);
        this.cloudCollide[2] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[2].setPosition(105,150);
        cloud.addChild(this.cloudCollide[2]);
        this.cloudCollide[3] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[3].setPosition(95,146);
        cloud.addChild(this.cloudCollide[3]);
        this.cloudCollide[4] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[4].setPosition(85,142);
        cloud.addChild(this.cloudCollide[4]);
        this.cloudCollide[5] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[5].setPosition(78,133);
        cloud.addChild(this.cloudCollide[5]);
        this.cloudCollide[6] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[6].setPosition(70,123);
        cloud.addChild(this.cloudCollide[6]);
        this.cloudCollide[7] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[7].setPosition(64,113);
        cloud.addChild(this.cloudCollide[7]);
        this.cloudCollide[8] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[8].setPosition(56,103);
        cloud.addChild(this.cloudCollide[8]);
        this.cloudCollide[9] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[9].setPosition(46,103);
        cloud.addChild(this.cloudCollide[9]);
        this.cloudCollide[10] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[10].setPosition(36,98);
        cloud.addChild(this.cloudCollide[10]);
        this.cloudCollide[11] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[11].setPosition(26,94);
        cloud.addChild(this.cloudCollide[11]);
        this.cloudCollide[12] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[12].setPosition(16,85);
        cloud.addChild(this.cloudCollide[12]);
        this.cloudCollide[13] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[13].setPosition(10,75);
        cloud.addChild(this.cloudCollide[13]);
        this.cloudCollide[14] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[14].setPosition(5,65);
        cloud.addChild(this.cloudCollide[14]);
        this.cloudCollide[15] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,30));
        this.cloudCollide[15].setPosition(3,45);
        cloud.addChild(this.cloudCollide[15]);
        this.cloudCollide[16] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[16].setPosition(8,25);
        cloud.addChild(this.cloudCollide[16]);
        this.cloudCollide[17] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[17].setPosition(15,15);
        cloud.addChild(this.cloudCollide[17]);
        this.cloudCollide[18] = new cc.Sprite(res.collide_png,cc.rect(0,0,200,10));
        this.cloudCollide[18].setPosition(115,5);
        cloud.addChild(this.cloudCollide[18]);
        this.cloudCollide[19] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[19].setPosition(220,10);
        cloud.addChild(this.cloudCollide[19]);
        this.cloudCollide[20] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[20].setPosition(230,17);
        cloud.addChild(this.cloudCollide[20]);
        this.cloudCollide[21] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[21].setPosition(235,26);
        cloud.addChild(this.cloudCollide[21]);
        this.cloudCollide[22] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,30));
        this.cloudCollide[22].setPosition(235,41);
        cloud.addChild(this.cloudCollide[22]);
        this.cloudCollide[23] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[23].setPosition(233,61);
        cloud.addChild(this.cloudCollide[23]);
        this.cloudCollide[24] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[24].setPosition(226,69);
        cloud.addChild(this.cloudCollide[24]);
        this.cloudCollide[25] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[25].setPosition(220,74);
        cloud.addChild(this.cloudCollide[25]);
        this.cloudCollide[26] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[26].setPosition(212,78);
        cloud.addChild(this.cloudCollide[26]);
        this.cloudCollide[27] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[27].setPosition(204,80);
        cloud.addChild(this.cloudCollide[27]);
        this.cloudCollide[28] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[28].setPosition(196,82);
        cloud.addChild(this.cloudCollide[28]);
        this.cloudCollide[29] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[29].setPosition(194,92);
        cloud.addChild(this.cloudCollide[29]);
        this.cloudCollide[30] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[30].setPosition(192,102);
        cloud.addChild(this.cloudCollide[30]);
        this.cloudCollide[31] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[31].setPosition(188,112);
        cloud.addChild(this.cloudCollide[31]);
        this.cloudCollide[32] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[32].setPosition(184,122);
        cloud.addChild(this.cloudCollide[32]);
        this.cloudCollide[33] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[33].setPosition(176,132);
        cloud.addChild(this.cloudCollide[33]);
        this.cloudCollide[34] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[34].setPosition(168,140);
        cloud.addChild(this.cloudCollide[34]);
        this.cloudCollide[35] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[35].setPosition(158,145);
        cloud.addChild(this.cloudCollide[35]);
        this.cloudCollide[36] = new cc.Sprite(res.collide_png,cc.rect(0,0,10,10));
        this.cloudCollide[36].setPosition(148,150);
        cloud.addChild(this.cloudCollide[36]);
        this.cloudCollide[37] = new cc.Sprite(res.collide_png,cc.rect(0,0,20,10));
        this.cloudCollide[37].setPosition(138,153);
        cloud.addChild(this.cloudCollide[37]);
        this.cloudCollide[38] = new cc.Sprite(res.collide_png,cc.rect(0,0,178,77));
        this.cloudCollide[38].setPosition(107,46);
        cloud.addChild(this.cloudCollide[38]);
        for(var i=0;i<=38;i++)
        {
            this.cloudCollide[i].visible = false;
            this.cloudCollide[i].active = false;
        }

        if(winSize.width/winSize.height>375/620)
        {
            scale = 0.8;
        }else{
            scale = 1;
        }

        if(this.cloudMax%2==0)
        {
            cloud.x = 130+Math.random()*100;
            if(first)
            {
                cloud.y = 750*scale+Math.random()*200;
            }else{
                cloud.y = 1200*scale+Math.random()*300;
            }
        }else{
            cloud.x = 850+Math.random()*100;
            cloud.y = 1200*scale;
        }
        if(!first)
        {
            var cloudTargetY = cloud.y;
            cloud.y = winSize.height+cloud.height;
            var moveToAction = cc.moveTo(0.3,cloud.x,cloudTargetY);
            cloud.runAction(moveToAction);
        }
        this.cloudMax++;
        this.addChild(cloud,2);
        this.cloudList.push(cloud);
    },
    initCat:function()
    {
        g_gameSharedLayer.cat = new cc.Sprite(res.cat_png);
        g_gameSharedLayer.cat.catFlip = false;
        g_gameSharedLayer.cat.schedule(function(dt){
            g_gameSharedLayer.cat.catFlip = !g_gameSharedLayer.cat.catFlip;
            if(g_gameSharedLayer.cat.catFlip)
            {
                g_gameSharedLayer.cat.x = g_gameSharedLayer.cat.sourceX+40;
                g_gameSharedLayer.cat.setTexture(res.cat_1_png);
            }else{
                g_gameSharedLayer.cat.x = g_gameSharedLayer.cat.sourceX-40;
                g_gameSharedLayer.cat.setTexture(res.cat_0_png);
            }
        }.bind(this),0.5);
        g_gameSharedLayer.cat.sourceX = this.cloudList[this.cloudCurrent].x;
        console.log(g_gameSharedLayer.cat.sourceX);
        g_gameSharedLayer.cat.setPosition(g_gameSharedLayer.cat.sourceX-40,this.cloudList[this.cloudCurrent].y+this.cloudList[this.cloudCurrent].height/2*this.cloudList[this.cloudCurrent].scale+this.cat.height/2);
        this.addChild(g_gameSharedLayer.cat,3);
    },

    changeReady:function()
    {
        console.log('changeready');
        this.cat.unscheduleAllCallbacks();
        this.cat.setTexture(res.blank_png);
        this.cat.setTextureRect(cc.rect(0,0,77,293));
        var catTop = new cc.Sprite(res.cat_2_top_png);
        catTop.setAnchorPoint(0.5,0);

        this.catCollideRect = [];
        this.catCollideRect[0] = new cc.Sprite(res.collide_png,cc.rect(0,0,50,50));
        this.catCollideRect[0].setPosition(36,188);
        catTop.addChild(this.catCollideRect[0],1,CAT_TAG_LIST.catCollideRect);

        this.catCollideRect[1] = new cc.Sprite(res.collide_png,cc.rect(0,0,30,30));
        this.catCollideRect[1].setPosition(36,133);
        catTop.addChild(this.catCollideRect[1],1,CAT_TAG_LIST.catCollideRect2);

        this.catCollideRect[2] = new cc.Sprite(res.collide_png,cc.rect(0,0,30,30));
        this.catCollideRect[2].setPosition(36,90);
        catTop.addChild(this.catCollideRect[2],1,CAT_TAG_LIST.catCollideRect3);

        this.catCollideRect[3] = new cc.Sprite(res.collide_png,cc.rect(0,0,50,50));
        this.catCollideRect[3].setPosition(36,40);
        catTop.addChild(this.catCollideRect[3],1,CAT_TAG_LIST.catCollideRect4);

        var catMiddle = new cc.Sprite(res.cat_2_middle_png);
        catMiddle.setAnchorPoint(0.5,0);
        var catBottom = new cc.Sprite(res.cat_2_bottom_png);
        catBottom.setAnchorPoint(0.5,0);
        catTop.sourceY = catMiddle.height+catBottom.height;
        catTop.setPosition(catTop.width/2,catTop.sourceY);

        catMiddle.setPosition(catTop.width/2,catBottom.height);
        catMiddle.scaleY = 1;
        catBottom.setPosition(catTop.width/2,0);
        this.cat.addChild(catTop,1,CAT_TAG_LIST.catTop);
        this.cat.addChild(catMiddle,1,CAT_TAG_LIST.catMiddle);
        this.cat.addChild(catBottom,1,CAT_TAG_LIST.catBottom);
        this.cat.x = this.cat.sourceX;
        this.cat.y = this.cat.y+60-this.cat.height/2;
        this.cat.setAnchorPoint(0.5,0);
        console.log(this.cat.getChildByTag(CAT_TAG_LIST.catMiddle));
        //this.cat.getChildByTag(CAT_TAG_LIST.catMiddle).setPosition(this.cat.getChildByTag(CAT_TAG_LIST.catBottom).x+this.cat.getChildByTag(CAT_TAG_LIST.catBottom).height*Math.sin(2*Math.PI/360*10),this.cat.getChildByTag(CAT_TAG_LIST.catBottom).y+this.cat.getChildByTag(CAT_TAG_LIST.catBottom).height*Math.cos(2*Math.PI/360*10));
        //this.cat.getChildByTag(CAT_TAG_LIST.catTop).setPosition(this.cat.getChildByTag(CAT_TAG_LIST.catTop).x+(this.cat.getChildByTag(CAT_TAG_LIST.catBottom).height+this.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*this.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY)*Math.sin(2*Math.PI/360*10),this.cat.getChildByTag(CAT_TAG_LIST.catBottom).y+(this.cat.getChildByTag(CAT_TAG_LIST.catBottom).height+this.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*this.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY)*Math.cos(2*Math.PI/360*10));
        //this.cat.getChildByTag(CAT_TAG_LIST.catTop).setRotation(10);
        //this.cat.getChildByTag(CAT_TAG_LIST.catMiddle).setRotation(10);
        //this.cat.getChildByTag(CAT_TAG_LIST.catBottom).setRotation(10);
        //return;
        this.cat.schedule(function(dt){
            if(this.cloudCurrent%2==0)
            {
                g_gameSharedLayer.rotateSpeed = Math.abs(ROTATE_SPEED)+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).getRotation()/20;
                if(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).getRotation()>=180)
                {
                    console.log(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).getRotation());
                    console.log('gameOver');
                    g_gameSharedLayer.gameOver();
                    if(GAME_SOUND)
                    {
                        cc.audioEngine.playEffect(res.maojiaodown_mp3);
                    }
                    return;
                }
            }else{
                g_gameSharedLayer.rotateSpeed = -Math.abs(ROTATE_SPEED)+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).getRotation()/20;
                if(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).getRotation()<=-180)
                {
                    console.log('gameOver');
                    g_gameSharedLayer.gameOver();
                    if(GAME_SOUND)
                    {
                        cc.audioEngine.playEffect(res.maojiaodown_mp3);
                    }
                    return;
                }
            }
            var rotateAngle = g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).getRotation()+1*g_gameSharedLayer.rotateSpeed;
            //g_gameSharedLayer.cat.setRotation(g_gameSharedLayer.cat.getRotation()+1*g_gameSharedLayer.rotateSpeed);
            g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).setRotation(rotateAngle);
            g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).setRotation(rotateAngle);
            g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).setRotation(rotateAngle);
            //g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).setRotation(rotateAngle);
            g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).setPosition(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).x+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height-1)*Math.sin(2*Math.PI/360*rotateAngle),g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).y+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height-1)*Math.cos(2*Math.PI/360*rotateAngle));
            g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).setPosition(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).x+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height-2+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY)*Math.sin(2*Math.PI/360*rotateAngle),g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).y+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height-2+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY)*Math.cos(2*Math.PI/360*rotateAngle));
            //g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).setPosition(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).x+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).height-g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).height)*Math.sin(2*Math.PI/360*rotateAngle),g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).y+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).height-g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).height)*Math.cos(2*Math.PI/360*rotateAngle));
            /*
            if(this.cloudCurrent%2==0)
            {
                //var rotateAction = cc.rotateBy(0,1*g_gameSharedLayer.rotateSpeed);
                if(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).getRotation()>=90 || g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).getRotation()<=0)
                {
                    if(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).getRotation()>=90)
                    {
                        //g_gameSharedLayer.cat.setRotation(89);
                        rotateAngle = 89;
                    }else{
                        //g_gameSharedLayer.cat.setRotation(1);
                        rotateAngle = 1;
                    }
                    g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).setRotation(rotateAngle);
                    g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).setRotation(rotateAngle);
                    g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).setRotation(rotateAngle);
                    g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).setRotation(rotateAngle);
                    g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).setPosition(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).x+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height*Math.sin(2*Math.PI/360*rotateAngle),g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).y+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height*Math.cos(2*Math.PI/360*rotateAngle));
                    g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).setPosition(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).x+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY)*Math.sin(2*Math.PI/360*rotateAngle),g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).y+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY)*Math.cos(2*Math.PI/360*rotateAngle));
                    g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).setPosition(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).x+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).height-g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).height)*Math.sin(2*Math.PI/360*rotateAngle),g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).y+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).height-g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).height)*Math.cos(2*Math.PI/360*rotateAngle));
                    g_gameSharedLayer.rotateSpeed = -g_gameSharedLayer.rotateSpeed;
                }
            }else{
                if(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).getRotation()<=-90 || g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).getRotation()>=0)
                {
                    if(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).getRotation()<=-90)
                    {
                        //g_gameSharedLayer.cat.setRotation(-89);
                        rotateAngle = -89;
                    }else{
                        //g_gameSharedLayer.cat.setRotation(-1);
                        rotateAngle = -1;
                    }
                    g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).setRotation(rotateAngle);
                    g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).setRotation(rotateAngle);
                    g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).setRotation(rotateAngle);
                    g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).setRotation(rotateAngle);
                    g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).setPosition(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).x+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height*Math.sin(2*Math.PI/360*rotateAngle),g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).y+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height*Math.cos(2*Math.PI/360*rotateAngle));
                    g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).setPosition(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).x+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY)*Math.sin(2*Math.PI/360*rotateAngle),g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).y+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY)*Math.cos(2*Math.PI/360*rotateAngle));
                    g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).setPosition(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).x+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).height-g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).height)*Math.sin(2*Math.PI/360*rotateAngle),g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).y+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).height-g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).height)*Math.cos(2*Math.PI/360*rotateAngle));
                    g_gameSharedLayer.rotateSpeed = -g_gameSharedLayer.rotateSpeed;
                }
            }
            */
            //g_gameSharedLayer.cat.runAction(rotateAction);
        }.bind(this),0.03);
    },

    changeToGo:function()
    {
        console.log('changetogo');
        if(GAME_SOUND)
        {
            cc.audioEngine.playEffect(res.bianchang_mp3,true);
        }
        g_gameSharedLayer.cat.unscheduleAllCallbacks();
        g_gameSharedLayer.cat.schedule(function(dt){
            //console.log(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle));
            g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY += 30;
            //g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).y = g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).sourceY+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY-1)
            rotateAngle = g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).getRotation();
            g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).setPosition(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).x+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height-1)*Math.sin(2*Math.PI/360*rotateAngle),g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).y+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height-1)*Math.cos(2*Math.PI/360*rotateAngle));
            g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).setPosition(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).x+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height-2+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY)*Math.sin(2*Math.PI/360*rotateAngle),g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).y-1+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height-2+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY)*Math.cos(2*Math.PI/360*rotateAngle));
            //g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).setPosition(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).x+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).height-g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).height)*Math.sin(2*Math.PI/360*rotateAngle),g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).y+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).height-g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).height)*Math.cos(2*Math.PI/360*rotateAngle));
            g_gameSharedLayer.checkGameOver(dt);
        }.bind(this));
    },

    changeGo:function()
    {
        g_gameSharedLayer.cat.unscheduleAllCallbacks();
        console.log('changego');
        cc.audioEngine.stopAllEffects();
        g_gameSharedLayer.cat.schedule(function(dt){
            g_gameSharedLayer.rotateSpeed = (g_gameSharedLayer.cloudCurrent%2==0 ? 1 : -1) *(ROTATE_SPEED*2+Math.abs(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).getRotation()/20));
            var rotateAngle = g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).getRotation()+1*g_gameSharedLayer.rotateSpeed;
            //g_gameSharedLayer.cat.setRotation(g_gameSharedLayer.cat.getRotation()+1*g_gameSharedLayer.rotateSpeed);
            g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).setRotation(rotateAngle);
            g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).setRotation(rotateAngle);
            g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).setRotation(rotateAngle);
            //g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).setRotation(rotateAngle);
            g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).setPosition(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).x+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height-1)*Math.sin(2*Math.PI/360*rotateAngle),g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).y+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height-1)*Math.cos(2*Math.PI/360*rotateAngle));
            g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).setPosition(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).x+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height-1+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY)*Math.sin(2*Math.PI/360*rotateAngle),g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).y+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height-1+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY)*Math.cos(2*Math.PI/360*rotateAngle));
            //g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).setPosition(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).x+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).height-g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).height)*Math.sin(2*Math.PI/360*rotateAngle),g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).y+(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).height+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY+g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).height-g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catCollideRect).height)*Math.cos(2*Math.PI/360*rotateAngle));
            //g_gameSharedLayer.cat.runAction(rotateAction);
            g_gameSharedLayer.checkGameOver(dt);
        }.bind(this),0.03);
    },

    update:function(dt)
    {
        this.labelScore.setString(SCORE);
        this.moon.scale = MOON_INIT_SCALE+SCORE/200;
        if(this.moon.scale>1)
        {
            this.moon.scale = 1;
        }
    },

    checkGameOver:function(dt)
    {
        if(!this.gameState)
        {
            return;
        }
        if(this.cloudCurrent%2==0)
        {
            //var rotateAction = cc.rotateBy(0,1*g_gameSharedLayer.rotateSpeed);
            if(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).getRotation()>=180)
            {
                console.log('gameOver');
                g_gameSharedLayer.gameOver();
                if(GAME_SOUND)
                {
                    cc.audioEngine.playEffect(res.maojiaodown_mp3);
                }
            }
        }else{
            if(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).getRotation()<=-180)
            {
                console.log('gameOver');
                g_gameSharedLayer.gameOver();
                if(GAME_SOUND)
                {
                    cc.audioEngine.playEffect(res.maojiaodown_mp3);
                }
            }
        }
        var nextCloud = this.cloudList[this.cloudCurrent+1];
        if(!nextCloud)
        {
            return;
        }
        var catTop = g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop);
        var rotateAngle = catTop.getRotation();
        var catCollide = catTop.getChildByTag(CAT_TAG_LIST.catCollideRect);
        var catCollide2 = [];
        catCollide2[0] = catTop.getChildByTag(CAT_TAG_LIST.catCollideRect2);
        catCollide2[1] = catTop.getChildByTag(CAT_TAG_LIST.catCollideRect3);
        catCollide2[2] = catTop.getChildByTag(CAT_TAG_LIST.catCollideRect4);
        console.log(catCollide);
        //var cloudRect = cc.rect(nextCloud.x+40-nextCloud.width/2,nextCloud.y+40-nextCloud.height/2,nextCloud.width-80,nextCloud.height-80);
        var catTopRect = cc.rect(g_gameSharedLayer.cat.x+catTop.x-catTop.width/2,g_gameSharedLayer.cat.y+catTop.y,catTop.width,catTop.height);
        //var catCollideRect = cc.rect(g_gameSharedLayer.cat.x+catCollide.x-g_gameSharedLayer.cat.width/2,g_gameSharedLayer.cat.y+catCollide.y+catCollide.height-catCollide.height,catCollide.width,catCollide.height);
        console.log(catTop.y);
        var catCollideRect = cc.rect(catTopRect.x+(catCollide.y*Math.sin(2*Math.PI/360*rotateAngle))+(catCollide.height/2*Math.sin(2*Math.PI/360*rotateAngle))-catCollide.width/2,catTopRect.y+(catCollide.y*Math.cos(2*Math.PI/360*rotateAngle))+(catCollide.height/2*Math.cos(2*Math.PI/360*rotateAngle))-catCollide.height/2,catCollide.width,catCollide.height);
        var catCollideRect2 = [];
        catCollideRect2[0] = cc.rect(catTopRect.x+(catCollide2[0].y*Math.sin(2*Math.PI/360*rotateAngle))+(catCollide2[0].height/2*Math.sin(2*Math.PI/360*rotateAngle))-catCollide2[0].width/2,catTopRect.y+(catCollide2[0].y*Math.cos(2*Math.PI/360*rotateAngle))+(catCollide2[0].height/2*Math.cos(2*Math.PI/360*rotateAngle))-catCollide2[0].height/2,catCollide2[0].width,catCollide2[0].height);
        catCollideRect2[1] = cc.rect(catTopRect.x+(catCollide2[1].y*Math.sin(2*Math.PI/360*rotateAngle))+(catCollide2[1].height/2*Math.sin(2*Math.PI/360*rotateAngle))-catCollide2[1].width/2,catTopRect.y+(catCollide2[1].y*Math.cos(2*Math.PI/360*rotateAngle))+(catCollide2[1].height/2*Math.cos(2*Math.PI/360*rotateAngle))-catCollide2[1].height/2,catCollide2[1].width,catCollide2[1].height);
        catCollideRect2[2] = cc.rect(catTopRect.x+(catCollide2[2].y*Math.sin(2*Math.PI/360*rotateAngle))+(catCollide2[2].height/2*Math.sin(2*Math.PI/360*rotateAngle))-catCollide2[2].width/2,catTopRect.y+(catCollide2[2].y*Math.cos(2*Math.PI/360*rotateAngle))+(catCollide2[2].height/2*Math.cos(2*Math.PI/360*rotateAngle))-catCollide2[2].height/2,catCollide2[2].width,catCollide2[2].height);
        var cloudRect;
        for(var i=0;i<=38;i++)
        {
            cloudRect = cc.rect(nextCloud.x-nextCloud.width/2*nextCloud.scale+this.cloudCollide[i].x*nextCloud.scale-this.cloudCollide[i].width/2*nextCloud.scale,nextCloud.y-nextCloud.height/2*nextCloud.scale+this.cloudCollide[i].y*nextCloud.scale-this.cloudCollide[i].height/2*nextCloud.scale,this.cloudCollide[i].width*nextCloud.scale,this.cloudCollide[i].height*nextCloud.scale);
            //console.log(cloudRect);
            //console.log(catCollideRect);
            if(cc.rectIntersectsRect(cloudRect,catCollideRect))
            {
                console.log('success');
                g_gameSharedLayer.step = 3;
                SCORE++;
                g_gameSharedLayer.cat.unscheduleAllCallbacks();
                cc.audioEngine.stopAllEffects();
                this.catRecover();
                return;
            }
        }
        /*
        for(var i=0;i<=37;i++)
        {
            cloudRect = cc.rect(nextCloud.x-nextCloud.width/2*nextCloud.scale+this.cloudCollide[i].x*nextCloud.scale-this.cloudCollide[i].width/2*nextCloud.scale,nextCloud.y-nextCloud.height/2*nextCloud.scale+this.cloudCollide[i].y*nextCloud.scale-this.cloudCollide[i].height/2*nextCloud.scale,this.cloudCollide[i].width*nextCloud.scale,this.cloudCollide[i].height*nextCloud.scale);
            for(var j=0;j<3;j++)
            {
                if(j==2)
                {
                    //console.log(cloudRect);
                    //console.log(catCollideRect2[j]);
                }
                if(cc.rectIntersectsRect(cloudRect,catCollideRect2[j]))
                {
                    //console.log(cloudRect);
                    //console.log(catCollideRect2[j]);
                    console.log('gameOver');
                    g_gameSharedLayer.gameOver();
                    if(GAME_SOUND)
                    {
                        cc.audioEngine.playEffect(res.maojiaohit_mp3);
                    }
                    break;
                }
            }
        }
        */
    },
    catRecover:function()
    {
        this.cat.getChildByTag(CAT_TAG_LIST.catMiddle).setAnchorPoint(0.5,0.99);
        this.cat.getChildByTag(CAT_TAG_LIST.catBottom).setAnchorPoint(0.5,0.9);
        this.cat.getChildByTag(CAT_TAG_LIST.catBottom).setPosition(this.cat.getChildByTag(CAT_TAG_LIST.catMiddle).x,this.cat.getChildByTag(CAT_TAG_LIST.catMiddle).y);
        this.cat.getChildByTag(CAT_TAG_LIST.catMiddle).setPosition(this.cat.getChildByTag(CAT_TAG_LIST.catTop).x,this.cat.getChildByTag(CAT_TAG_LIST.catTop).y);
        this.cat.schedule(function(dt){
            if(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY<=80)
            {
                g_gameSharedLayer.cat.unscheduleAllCallbacks();
                g_gameSharedLayer.step = 0;
                g_gameSharedLayer.cat.active = false;
                g_gameSharedLayer.cat.visible = false;
                g_gameSharedLayer.cloudCurrent++;
                g_gameSharedLayer.scheduleOnce(function(){
                    moveByAction = cc.moveBy(1,0,-winSize.height);
                    moveByCallBackAction = cc.callFunc(function(sender){sender.active=false;sender.visible=false;}.bind(this),this);
                    g_gameSharedLayer.cloudList[this.cloudCurrent-1].runAction(cc.sequence(moveByAction,moveByCallBackAction));
                    var targetY = 800+Math.random()*200;
                    catMoveToAction = cc.moveTo(0.2,g_gameSharedLayer.cat.x,targetY);
                    cloudMoveToAction = cc.moveTo(0.2,g_gameSharedLayer.cloudList[this.cloudCurrent].x,targetY-g_gameSharedLayer.cat.height/2-g_gameSharedLayer.cloudList[this.cloudCurrent].height/2*g_gameSharedLayer.cloudList[this.cloudCurrent].scale);
                    g_gameSharedLayer.cat.runAction(catMoveToAction);
                    g_gameSharedLayer.cloudList[this.cloudCurrent].runAction(cloudMoveToAction);
                    g_gameSharedLayer.scheduleOnce(function(){g_gameSharedLayer.initCloud();}.bind(this));
                }.bind(this),0.5);
                g_gameSharedLayer.initCat();
            }
            if(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle))
            {
                g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY -= 80;
                rotateAngle = g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).getRotation();
                g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catBottom).setPosition(g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).x-g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY*Math.sin(2*Math.PI/360*rotateAngle),g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catTop).y-g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).height*g_gameSharedLayer.cat.getChildByTag(CAT_TAG_LIST.catMiddle).scaleY*Math.cos(2*Math.PI/360*rotateAngle));
            }
        }.bind(this), 0.05);
        scaleByAction = cc.scaleBy(0.2,1.2);
        g_gameSharedLayer.cloudList[this.cloudCurrent+1].runAction(cc.sequence(scaleByAction,scaleByAction.reverse()));
        if(GAME_SOUND)
        {
            cc.audioEngine.playEffect(res.maojiaoget_mp3);
        }
    },
    gameOver:function()
    {
        if(!this.gameState)
        {
            return;
        }
        this.gameState = false;
        if(GAME_SOUND)
        {
            cc.audioEngine.stopAllEffects();
        }
        this.cat.unscheduleAllCallbacks();
        var blood = new cc.Sprite(res.blood_png);
        blood.setPosition(this.cat.getChildByTag(CAT_TAG_LIST.catTop).width/2,this.cat.getChildByTag(CAT_TAG_LIST.catTop).height/2)
        this.cat.getChildByTag(CAT_TAG_LIST.catTop).addChild(blood);
        this.scheduleOnce(function(){
            cc.director.runScene(new GameOverScene());
        }.bind(this),0.5);
    }
});

var GameScene = cc.Scene.extend({
    onEnter:function () {
        this._super();
        var layer = new GameLayer();
        this.addChild(layer);
    }
});

