var g_menuSharedLayer;
var MenuLayer = cc.Layer.extend({
    ctor:function(){
        g_menuSharedLayer = this;
        this._super();
        this.init();
    },
    init:function () {
        winSize = cc.director.getWinSize();
        if(winSize.width/winSize.height>375/620)
        {
        //ipad
        scale = 0.8;
        }else{
        scale = 1;
        }
        if(!GAME_SPLASH_SHOW)
        {
        switch(cc.sys.language)
        {
            case 'en':
                var logoSplashBGSprite = new cc.Sprite(res.logo_bg_splash_en_png);
                break;
            case 'zh':
                var logoSplashBGSprite = new cc.Sprite(res.logo_bg_splash_png);
                break;
            default:
                var logoSplashBGSprite = new cc.Sprite(res.logo_bg_splash_png);
                break;
        }
        logoSplashBGSprite.setAnchorPoint(0,0);
        this.addChild(logoSplashBGSprite,10);
        
        var logoSplashSprite = new cc.Sprite(res.logo_splash_png);
        logoSplashSprite.setPosition(winSize.width/2,winSize.height/2+200);
        logoSplashBGSprite.addChild(logoSplashSprite);
        logoSplashSpriteAction1 = cc.moveBy(0.8,0,20);
        logoSplashSpriteAction2 = cc.moveBy(0.5,0,winSize.height/2+200);
        logoSplashSpriteAction3 = cc.fadeOut(0.5);
        logoSplashSpriteAction4 = cc.callFunc(function(sender){logoSplashBGSprite.visible = false;logoSplashBGSprite.active = false;}.bind(this),this);
        logoSplashSprite.runAction(cc.sequence(logoSplashSpriteAction1,logoSplashSpriteAction1.reverse(),logoSplashSpriteAction1,logoSplashSpriteAction1.reverse(),cc.spawn(logoSplashSpriteAction2,logoSplashSpriteAction3),logoSplashSpriteAction4));
        GAME_SPLASH_SHOW = true;
        }
        var bgSprite = new cc.Sprite(res.bg_png);
        bgSprite.setAnchorPoint(0,0);
        this.addChild(bgSprite,0);
        var moon = new cc.Sprite(res.moon_png);
        moon.setPosition(winSize.width/2,winSize.height-moon.height/2*scale);
        moon.setScale(scale);
        this.addChild(moon,1);

        switch(cc.sys.language)
        {
            case 'en':
                var logoText = new cc.Sprite(res.logo_text_en_png);
                break;
            case 'zh':
                var logoText = new cc.Sprite(res.logo_text_png);
                break;
            default:
                var logoText = new cc.Sprite(res.logo_text_png);
                break;
        }
        logoText.setPosition(winSize.width/2-135,winSize.height/2+70);
        logoText.setScale(scale);
        this.addChild(logoText,1);

        var startButton = new cc.MenuItemImage(res.go_png, res.go_png, this.startGame,this);
        var startButtonMenu = new cc.Menu(startButton);
        startButtonMenu.setPosition(winSize.width/2+220,winSize.height/2+40);
        this.addChild(startButtonMenu,1,CAT_TAG_LIST.startButton);
        moveByAction1 = cc.moveBy(0.5,0,-5);
        moveByAction1CallBack = cc.callFunc(function(sender){
            var moveByAction1 = cc.moveBy(1,0,10);
            var moveByAction2 = cc.moveBy(1,0,-10);
            sender.runAction(cc.sequence(moveByAction1,moveByAction2).repeatForever());
        }.bind(this),this);
        startButtonMenu.runAction(cc.sequence(moveByAction1,moveByAction1CallBack));

        var logoCat = new cc.Sprite(res.logo_cat_png);
        logoCat.setPosition(winSize.width/2,(logoCat.height/2)*scale+84);
        logoCat.setScale(scale);
        this.addChild(logoCat,1);

        var helpButton = new cc.MenuItemImage(res.buttonHelp_png, res.buttonHelp_png, this.showHelp,this);
        var helpButtonMenu = new cc.Menu(helpButton);
        helpButtonMenu.setPosition(186,330);
        this.addChild(helpButtonMenu,1,CAT_TAG_LIST.helpButton);

        if(GAME_SOUND)
        {
            var soundButton = new cc.MenuItemImage(res.buttonSound_png, res.buttonSound_png, this.soundControlHandle,this);
        }else{
            var soundButton = new cc.MenuItemImage(res.buttonNoSound_png, res.buttonNoSound_png, this.soundControlHandle,this);
        }
        var soundButtonMenu = new cc.Menu(soundButton);
        soundButtonMenu.setPosition(winSize.width-186,330);
        this.addChild(soundButtonMenu,1,CAT_TAG_LIST.soundButton);
        /*
        if ('mouse' in cc.sys.capabilities)
            cc.eventManager.addListener({
                event: cc.EventListener.MOUSE,
                onMouseDown: function(event){
                    if(event.getButton() == cc.EventMouse.BUTTON_LEFT)
                    {
                        alert(1);
                        g_menuSharedLayer.showHelp();
                    }
                }
            }, helpButton);
            cc.eventManager.addListener({
                event: cc.EventListener.MOUSE,
                onMouseDown: function(event){
                    if(event.getButton() == cc.EventMouse.BUTTON_LEFT)
                    {
                        alert(2);
                        g_menuSharedLayer.soundControlHandle();
                    }
                }
            }, soundButton);
            cc.eventManager.addListener({
                event: cc.EventListener.MOUSE,
                onMouseDown: function(event){
                    if(event.getButton() == cc.EventMouse.BUTTON_LEFT)
                    {
                        g_menuSharedLayer.startGame();
                    }
                }
            }, startButton);

        if (cc.sys.capabilities.hasOwnProperty('touches')){
            cc.eventManager.addListener({
                event: cc.EventListener.TOUCH_ALL_AT_ONCE,
                onTouchesEnded:function (touches, event) {
                    var touch = touches[0];
                    g_menuSharedLayer.showHelp();
                }
            }, helpButton);
            cc.eventManager.addListener({
                event: cc.EventListener.TOUCH_ALL_AT_ONCE,
                onTouchesEnded:function (touches, event) {
                    var touch = touches[0];
                    g_menuSharedLayer.soundControlHandle();
                }
            }, soundButton);
            cc.eventManager.addListener({
                event: cc.EventListener.TOUCH_ALL_AT_ONCE,
                onTouchesEnded:function (touches, event) {
                    var touch = touches[0];
                    g_menuSharedLayer.startGame();
                }
            }, startButton);
        }
        */
        return true;
    },
    soundControlHandle:function () {
        GAME_SOUND = !GAME_SOUND;
        var childrens = this.getChildByTag(CAT_TAG_LIST.soundButton).getChildren();
        var child = childrens[0];
        if(GAME_SOUND)
        {
            child.setNormalImage(new cc.Sprite(res.buttonSound_png));
        }else{
            child.setNormalImage(new cc.Sprite(res.buttonNoSound_png));
        }
    },
    startGame:function()
    {
        var scene = new GameScene();
        cc.director.runScene(scene);
    },
    showHelp:function()
    {
        if(!this.getChildByTag(CAT_TAG_LIST.helpText))
        {
            switch(cc.sys.language)
            {
                case 'en':
                    helpText = new cc.Sprite(res.help_text_en_png);
                    break;
                case 'zh':
                    helpText = new cc.Sprite(res.help_text_png);
                    break;
                default:
                    helpText = new cc.Sprite(res.help_text_png);
                    break;
            }
            helpText.setPosition(winSize.width/2,winSize.height-550);
            this.addChild(helpText,1,CAT_TAG_LIST.helpText);
        }else{
            this.removeChildByTag(CAT_TAG_LIST.helpText);
        }
    }
});

var MenuScene = cc.Scene.extend({
    onEnter:function () {
        this._super();
        var layer = new MenuLayer();
        this.addChild(layer);
    }
});

